// Here's an example of usage of the FBWS macro.
// A simple box of polystyrene.
// Diego Krota, 1998.
// dkrota@geocities.com
// http://www.geocities.com/SiliconValley/Way/2419/POVMacros.html

#include "colors.inc"
#include "shapes.inc"
#include "textures.inc"
#include "fbws.inc"

#declare cantainer_width = 10;
#declare cantainer_height = 5;
#declare cantainer_depth = 8;
#declare number_of_spheres = 1000;
#declare sphere_max_radius = 0.7;
#declare sphere_min_radius = 0.5;
#declare intersect = yes;
#declare contain_all = yes;
 
camera{
	location  <10, 10, -10>
	look_at   <0, 0,  0>
}

light_source{ <1, 1, -1> * 100 color White * 1.5}

#declare polystyrene_box = FBWS (cantainer_width, cantainer_height, cantainer_depth, number_of_spheres,
									sphere_max_radius, sphere_min_radius, intersect, contain_all)

object{
	polystyrene_box
	pigment{color White}
}



