// Fill Box With Spheres POV-Ray Macro
// Version 1.1.0
// Diego Krota, 1998.
// dkrota@geocities.com
// http://www.geocities.com/SiliconValley/Way/2419/POVMacros.html

#macro FBWS (cantainer_width, cantainer_height, cantainer_depth, number_of_spheres, sphere_max_radius, sphere_min_radius, intersect, contain_all)
	#debug "\nFBWS Macro: running\n"
	#if (cantainer_width < 0)
		#declare cantainer_width = abs(cantainer_width);
		#debug "warning: \"cantainer_width\" cannot be negative! Converted to "
		#debug str(cantainer_width, 0, 9)
		#debug "\n"
	#end
	#if (cantainer_height < 0)
		#declare cantainer_height = abs(cantainer_height);
		#debug "warning: \"cantainer_height\" cannot be negative! Converted to "
		#debug str(cantainer_height, 0, 9)
		#debug "\n"
	#end
	#if (cantainer_depth < 0)
		#declare cantainer_depth = abs(cantainer_depth);
		#debug "warning: \"cantainer_depth\" cannot be negative! Converted to "
		#debug str(cantainer_depth, 0, 9)
		#debug "\n"
	#end
	#if (number_of_spheres < 1)
		#declare number_of_spheres = 1;
		#debug "warning: \"number_of_spheres\" cannot be less than \"1\"! Converted to \"1\"\n"
	#else
		#declare number_of_spheres = int(number_of_spheres);
	#end
		#if (sphere_min_radius < 0)
		#declare sphere_min_radius = abs(sphere_min_radius);
		#debug "warning: \"sphere_min_radius\" cannot be negative ! Converted to "
		#debug str(sphere_min_radius, 0, 9)
		#debug "\n"
	#end
	#if (sphere_min_radius = 0)
		#declare sphere_min_radius = 1;
		#debug "warning: \"sphere_min_radius\" cannot be than \"0\"! Converted to \"1\"\n"
	#end
	#if (sphere_max_radius < sphere_min_radius)
		#declare sphere_max_radius = sphere_min_radius;
		#debug "warning: \"sphere_max_radius\" cannot be less than \"sphere_min_radius\" ! Converted to "
		#debug str(sphere_max_radius, 0, 9)
		#debug "\n"
	#end
	#if (intersect != yes & intersect != no)
		#declare intersect = yes;
		#debug "warning: \"intersect\" must be \"yes\" or \"no\". Converted to \"yes\"\n"
	#end
	#if (contain_all != yes & contain_all != no)
		#declare contain_all = yes;
		#debug "warning: \"contain_all\" must be \"yes\" or \"no\". Converted to \"yes\"\n"
	#end
	#local sphere_center_array = array[number_of_spheres]
	#local sphere_radius_array = array[number_of_spheres]
	#local S1 = seed(1);
	#declare counter = 0;
	#while (counter < number_of_spheres)
		#local provv_radius = rand(S1) * (sphere_max_radius - sphere_min_radius) + sphere_min_radius;
		#if (contain_all = yes)
			#declare radius_offset = provv_radius;
		#else
			#declare radius_offset = 0;
		#end
		#local provv_center = <(rand(S1) - .5) * (cantainer_width - radius_offset * 2), (rand(S1) - .5) * (cantainer_height - radius_offset * 2), (rand(S1) - .5) * (cantainer_depth - radius_offset * 2)>;
		#if (counter > 0 & intersect = no)
			#declare compare = 0;
			#while (compare < counter)
				#declare sphere_is_good = true;
				#if (vlength(provv_center - sphere_center_array[compare]) < (provv_radius + sphere_radius_array[compare]))
					#declare sphere_is_good = false;
					#declare compare = counter;
				#else
					#declare compare = compare + 1;
				#end
			#end
			#if (sphere_is_good = true)
				#declare sphere_center_array[counter] = provv_center;
				#declare sphere_radius_array[counter] = provv_radius;
				#declare counter = counter + 1;
			#end
		#else
			#declare sphere_center_array[counter] = provv_center;
			#declare sphere_radius_array[counter] = provv_radius;
			#declare counter = counter + 1;
		#end
	#end
	
	#declare counter = 0;
	merge{
		#while (counter < number_of_spheres)
			sphere {
				sphere_center_array[counter],
				sphere_radius_array[counter]
			}
			#declare counter = counter + 1;
		#end
	}
	#debug "\nFBWS Macro: done"
#end

